
Ruby - Bug #12345

A module's private constants are given with `Module#constant(false)`

05/03/2016 10:05 PM - sawa (Tsuyoshi Sawada)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v:  Backport: 2.1: WONTFIX, 2.2: DONE, 2.3: DONE

Description

A module's private constants are given with Module#constant(false).

module A

  X = 1

  Y = 2

  private_constant :Y

end

module B

  Z = 3

  W = 4

  private_constant :W

end

A.constants        # => [:X]

A.constants(false) # => [:X, :Y]

A.include B

A.constants        # => [:X, :Z]

A.constants(false) # => [:X, :Y]

 Besides this, I request a way to get the private constants of a module. I want:

A.private_constants        # => [:Y]

A.private_constants(false) # => [:Y]

A.include B

A.private_constants        # => [:Y, :W]

A.private_constants(false) # => [:Y]

Associated revisions

Revision 6ea002a7a28ac11424798f448f1765ccf0513b95 - 07/19/2016 06:39 AM - nobu (Nobuyoshi Nakada)

variable.c: exclude private constants

variable.c (rb_local_constants_i): exclude private constants

when excluding inherited constants too.  [Bug #12345]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@55705 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 6ea002a7 - 07/19/2016 06:39 AM - nobu (Nobuyoshi Nakada)

variable.c: exclude private constants

variable.c (rb_local_constants_i): exclude private constants

when excluding inherited constants too.  [Bug #12345]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@55705 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 717f31e0756ac0f7c1e0c47c7a91356d0cbccc71 - 08/11/2016 06:39 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 55705: [Backport #12345]

    * variable.c (rb_local_constants_i): exclude private constants
      when excluding inherited constants too.  [Bug #12345]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@55868 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 717f31e0 - 08/11/2016 06:39 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 55705: [Backport #12345]

    * variable.c (rb_local_constants_i): exclude private constants

      when excluding inherited constants too.  [Bug #12345]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@55868 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision caec808f74a7545cc2b6930dbfa629071315f065 - 08/16/2016 05:56 AM - U.Nakamura 

merge revision(s) 55705: [Backport #12345]

    * variable.c (rb_local_constants_i): exclude private constants

      when excluding inherited constants too.  [Bug #12345]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_2@55930 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision caec808f - 08/16/2016 05:56 AM - U.Nakamura 

merge revision(s) 55705: [Backport #12345]

    * variable.c (rb_local_constants_i): exclude private constants

      when excluding inherited constants too.  [Bug #12345]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_2@55930 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 05/12/2016 02:14 AM - nobu (Nobuyoshi Nakada)

- Tracker changed from Bug to Feature

#2 - 06/13/2016 09:11 AM - shyouhei (Shyouhei Urabe)

Report upper half: is a bug, should be fixed.

#3 - 07/19/2016 06:27 AM - nobu (Nobuyoshi Nakada)

- Tracker changed from Feature to Bug

- Backport set to 2.1: UNKNOWN, 2.2: UNKNOWN, 2.3: UNKNOWN

#4 - 07/19/2016 06:39 AM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

Applied in changeset r55705.

variable.c: exclude private constants

variable.c (rb_local_constants_i): exclude private constants

when excluding inherited constants too.  [Bug #12345]

#5 - 08/04/2016 07:54 AM - usa (Usaku NAKAMURA)

- Backport changed from 2.1: UNKNOWN, 2.2: UNKNOWN, 2.3: UNKNOWN to 2.1: WONTFIX, 2.2: REQUIRED, 2.3: REQUIRED

#6 - 08/11/2016 06:39 PM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.1: WONTFIX, 2.2: REQUIRED, 2.3: REQUIRED to 2.1: WONTFIX, 2.2: REQUIRED, 2.3: DONE

ruby_2_3 r55868 merged revision(s) 55705.

#7 - 08/16/2016 05:56 AM - usa (Usaku NAKAMURA)

- Backport changed from 2.1: WONTFIX, 2.2: REQUIRED, 2.3: DONE to 2.1: WONTFIX, 2.2: DONE, 2.3: DONE

ruby_2_2 r55930 merged revision(s) 55705.
